# frozen_string_literal: true
module Hyrax
  module Workflow
    ##
    # This is a built in function for workflow, so that a workflow action can be created that
    # removes the creators the ability to alter it.
    module RevokeEditFromCrcManager
      def self.call(target:, **)  
        collection = target.parent_collections.first

        group_key = "#{collection.collection_type.title.parameterize(separator: '_')}_manager"
        crc_manager_role = Role.find_by(is_crc_manager: true)
        target.update(edit_groups: target.edit_groups.to_a - [group_key], edit_users: target.edit_users - crc_manager_role.users&.pluck(:email))

        RevokeEditFromGroupJob.perform_later(target, group_key)
      end
    end
  end
end